<?php

namespace Drupal\stubby\Entity;

use Drupal\Core\Config\Entity\ConfigEntityInterface;
use Drupal\stubby\ParameterInterface;

/**
 * Provides an interface for defining Stub entities.
 */
interface StubInterface extends ConfigEntityInterface {

  /**
   * Path Getter.
   */
  public function getPath();

  /**
   * Method Getter.
   */
  public function getMethods();

  /**
   * Response code Getter.
   */
  public function getResponseCode();

  /**
   * Response Message Getter.
   */
  public function getResponseMessage();

  /**
   * Response data Getter.
   */
  public function getResponseData();

  /**
   * Parameter Getter.
   *
   * @param string $parameter
   *   The parameter uuid.
   *
   * @return \Drupal\stubby\ParameterInterface
   *   A loaded parameter.
   */
  public function getParameter($parameter);

  /**
   * Load sorted parameters.
   */
  public function getParameters();

  /**
   * Adds a parameter to a stub collection.
   */
  public function addParameter(array $configuration);

  /**
   * Removes a parameter from a stub collection.
   */
  public function deleteParameter(ParameterInterface $parameter);

}
